#ifndef _BED_FILE_HPP_
#define _BED_FILE_HPP_

#include "include.hpp"
#include "basic_type.hpp"

typedef class Bed
{
public:
  string chromosome;
  size_t start;
  size_t end;
  string name;
public:
  bool operator<(const Bed &one) const;
  template <class T>
  bool operator<(const T &one) const;
  template <class T>
  bool operator==(const T &one) const;
  template <class T>
  bool operator>(const T &one) const;
}Bed;

typedef class Point
{
public:
  string chromosome;
  size_t position;
  string name;
  string annotation;
public:
  bool operator<(const Point &one) const;
  bool operator<(const Bed &one) const;
  bool operator>(const Bed &one) const;
  bool operator==(const Bed &one) const;
}Point;

typedef struct CGI_description
{
  vector<Bed> cgi;
  map<size_t, vector<string> > cgi_probe;
}CGI_description;

bool read_cgi(string cgi_file,
              vector<Bed> &cgi);

bool read_probe_ann(string &ann_file, vector<Point> &ann, map<string, size_t> &map_probe);

void cgi_probe(vector<Bed> &cgi,
               vector<Point> &ann_w,
               Data_description &data_des,
               map<string, size_t> &map_probe,
               map<size_t, vector<string> > &cgi_probe);

#endif
