#include "read_file.hpp"
#include "bed_file.hpp"
#include "parameter.hpp"
#include "normalize.hpp"
#include "probe_analysis.hpp"
#include "cgi_analysis.hpp"
#include "write_file.hpp"
#include "dmr_analysis.hpp"

int main(int argc, char *argv[])
{
  Data_description data_des;
  Parameter parameter;
  Data_matrix *data;
  CGI_result cgi_res;
  CGI_description cgi_des;
  Probe_result probe_res;
  vector<Point> ann;
  map<string, size_t> map_probe;
  DMR_result dmr_res;
  parameter=parameter_manipulate(argc, argv);
  data=read_data(parameter.configure_file, data_des, parameter.covariable_number, parameter.nproc, parameter);
  read_probe_ann(parameter.probe_ann_file, ann, map_probe);
  if (parameter.normalize)
  {
    normalize(data, parameter.nproc);
  }
  probe_analysis(data, parameter.nproc, data_des, probe_res);
  write_probe_result(data_des, probe_res, ann, map_probe, parameter);
  if (parameter.cgi)
  {
    read_cgi(parameter.cgi_file, cgi_des.cgi);
    cgi_probe(cgi_des.cgi, ann, data_des, map_probe, cgi_des.cgi_probe);
    cgi_analysis(data,parameter.nproc,parameter.cgi_file,data_des,cgi_res,cgi_des);
    write_cgi_result(parameter, data_des, probe_res, ann, map_probe, cgi_res, cgi_des);
  }
  if (parameter.dmr)
  {
    if (parameter.unify)
    {
      dmr_analysis_2(data_des, data, parameter, ann, map_probe, dmr_res);
    }
    else
    {
      dmr_analysis(data_des, probe_res, ann, map_probe, dmr_res);
    }
    write_dmr_result(parameter, data_des, probe_res, ann, map_probe, dmr_res);
  }
  return 0;
}
